﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr167_1
{
    // Объявление делегата:
    delegate char MyDelegate(int k, string txt);

    // Класс: 
    class MyClass {
        // Целочисленное поле: 
        public int code;
        // Конструктор: 
        public MyClass(int n) { 
            code = n;
        }
        // Нестатический метод с двумя аргументами: 
        public char getChar(int k, string txt) { 
            return (char)(txt[k] + code);
        }
        // Статический метод с двумя аргументами: 
        public static char getFirst(int k, string txt) { 
            return txt[k];
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Статический метод с двумя аргументами: 
        static char getLast(int k, string txt) {
            return txt[txt.Length - k - 1];
        }
        // Главный метод: 
        static void Main()
        {
            // Создание объекта:
            MyClass obj = new MyClass(5);
            // Создание экземпляра делегата:
            MyDelegate meth = new MyDelegate(obj.getChar);
            // Вызов экземпляра делегата:
            Console.WriteLine("Символ \'{0}\'", meth(4,"Alpha")); 
            // Присваивание значения полю объекта: 
            obj.code = 1;
            // Вызов экземпляра делегата:
            Console.WriteLine("Символ \'{0}\'", meth(4,"Alpha")); 
            // Присваивание нового значения переменной делегата: 
            meth = MyClass.getFirst;
            // Вызов экземпляра делегата:
            Console.WriteLine("Символ \'{0}\'", meth(2, "Alpha")); 
            // Присваивание нового значения переменной делегата: 
            meth = getLast;
            // Вызов экземпляра делегата:
            Console.WriteLine("Символ \'{0}\'", meth(1, "Alpha"));
            // Задержка:
            Console.ReadLine();
        }
    }
}
